if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_Operator_Get_DayTalkTime' ) )
 	Drop procedure dbo.A_TaskManager_Operator_Get_DayTalkTime
GO

if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_Operator_Get_FreeTime' ) )
	Drop procedure dbo.A_TaskManager_Operator_Get_FreeTime
GO

if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_Operator_Get_TaskWork' ) )
	Drop procedure dbo.A_TaskManager_Operator_Get_TaskWork
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_User_StartHandling' ) )
	Drop procedure dbo.A_TaskManager_User_StartHandling
GO

Create procedure [dbo].[A_TaskManager_User_StartHandling ]
	@id			uniqueidentifier,
	@userid			uniqueidentifier,
	@taskid			uniqueidentifier,
	@effortid		uniqueidentifier,
	@start			datetime,
	@stopprior		datetime = NULL,
	@stopwaitcall		datetime = NULL
as
begin

	--  TimeStopPrior  TimeStopWaitCall   
	--     
	--(      )
	
	Insert Into A_TaskManager_UserInTask --with ( TabLock )
			( Id, UserId, TaskId, EffortId, TimeStart, TimeStopPrior, TimeStopWaitCall )
		values
			( @id, @userid, @taskid, @effortid, @start, @stopprior, @stopwaitcall )

end
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_TaskWorkAll_AtStart' ) )
	Drop procedure dbo.A_TaskManager_OperatorsAll_Get_TaskWorkAll_AtStart
GO


Create    Procedure [dbo].[A_TaskManager_OperatorsAll_Get_TaskWorkAll_AtStart]
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.Id, Sum ( Convert ( float, TimeStopPost - TimeStart ) ) * 86400 as TaskWork_Days, TaskId
	From A_TaskManager_UserInTask uit with ( NOLOCK )
		Inner join A_Users u on uit.UserId = u.Id
		Inner join A_TaskManager_Tasks t on uit.TaskId = t.Id
		and FLOOR ( cast ( @dtnow as float ) ) = FLOOR ( cast ( TimeStopPost as float ) )
	Group By u.Id, TaskId
	Order by TaskId
end
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_FreeTime_AtStart' ) )
	Drop procedure dbo.A_TaskManager_OperatorsAll_Get_FreeTime_AtStart
GO

Create procedure [dbo].[A_TaskManager_OperatorsAll_Get_FreeTime_AtStart]
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.id, 
		Max ( TimeStop ) as TimeStop_Last
	From A_Stat_Connections_1x1 sc with ( Index  ( idx_StatConn_TStart_TStop ) )
		Inner join A_USers u on sc.AUserId = u.id or sc.BUserId = u.Id	
	Where FLOOR ( cast ( @dtnow as float ) ) = FLOOR ( cast ( TimeStop as float ) )		
	Group by u.Id
end
GO



if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_OperatorsAll_Get_DayTalkTime_AtStart' ) )
	Drop procedure dbo.A_TaskManager_OperatorsAll_Get_DayTalkTime_AtStart
GO

Create procedure [dbo].[A_TaskManager_OperatorsAll_Get_DayTalkTime_AtStart]
	@dtnow 			datetime = null
as
begin
	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Select u.Id, Sum ( Convert ( float, TimeStop - TimeStart ) ) * 86400 as DayTalks_Days
	From A_Stat_Connections_1x1 sc with ( Index  ( idx_StatConn_TStart_TStop ) )
		inner join A_Users u on sc.AUserId = u.Id or sc.BUserId = u.Id
	Where FLOOR ( cast ( @dtnow as float ) ) = FLOOR ( cast ( TimeStop as float ) )		
	Group by u.Id
end
GO





if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_CallCenter_LastConnected' ) )
	Drop Table dbo.A_CallCenter_LastConnected
GO

Create Table [dbo].[A_CallCenter_LastConnected]
(
	CallTime DateTime, 
	IdProject uniqueidentifier,
	IdTask uniqueidentifier,
	IdList uniqueidentifier,
	IdInList int,
	AbonentNumber nvarchar ( 50 ),
	IdOperator uniqueidentifier	
)
GO

if not exists ( select name from sysindexes where id=object_id('dbo.A_CallCenter_LastConnected') and name = 'idxCCLastConn_Task_Id' )
	CREATE INDEX idxCCLastConn_Task_Id ON dbo.A_CallCenter_LastConnected
	(
		IdTask, IdInList
	) WITH FILLFACTOR = 80
GO

if not exists ( select name from sysindexes where id=object_id('dbo.A_CallCenter_LastConnected') and name = 'idxCCLastConn_Task_Num' )
	CREATE INDEX idxCCLastConn_Task_Num ON dbo.A_CallCenter_LastConnected
	(
		IdTask, AbonentNumber
	) WITH FILLFACTOR = 80
GO

if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_CallCenter_OperatorLastConnected_Set' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastConnected_Set
GO

Create procedure [dbo].[A_CallCenter_OperatorLastConnected_Set]
	@calltime DateTime, 
	@idproject uniqueidentifier,
	@idtask uniqueidentifier,
	@idlist uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 50 ),
	@idoperator uniqueidentifier
as
begin
	Update A_CallCenter_LastConnected
	Set CallTime = @calltime,
		IdProject = @idproject,
		IdList = @idlist,
		IdOperator = @idoperator		
	Where IdTask = @idtask
		And IdInList = @idinlist
		And AbonentNumber = @number

	if ( @@rowcount = 0 )	
		Insert into A_CallCenter_LastConnected
		(CallTime, IdProject, IdTask, IdList, IdInList, AbonentNumber, IdOperator )
		Values 
		(@calltime, @idproject, @idtask, @idlist, @idinlist, @number, @idoperator)
end
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_CallCenter_OperatorLastConnected_Get' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastConnected_Get
GO

Create procedure [dbo].[A_CallCenter_OperatorLastConnected_Get]
	@idtask uniqueidentifier,
	@idpoint int,
	@number nvarchar ( 30 ),
	@searchintask bit,
	@searchinnumbers bit
as
begin
	--     ,    

	if ( @searchintask = 1 )
	begin
		if ( @searchinnumbers = 1 )
		begin
			Select IdOperator
			From A_CallCenter_LastConnected
			Where IdTask = @idtask 
				and AbonentNumber = @number
		end
		else
		begin
			Select IdOperator
			From A_CallCenter_LastConnected
			Where IdTask = @idtask 
				and IdInList = @idpoint
		end
	end
	else
	begin
		if ( @searchinnumbers = 1 )
		begin
			Select IdOperator
			From A_CallCenter_LastConnected
			Where AbonentNumber = @number
		end

		--         
		--        
	end
end
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterCallResult' ) )
	Drop procedure dbo.A_CallCenter_Temp_UpdateAfterCallResult
GO

Create  procedure [dbo].[A_CallCenter_Temp_UpdateAfterCallResult]
	@idchain uniqueidentifier,
	@ideffort uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@callresult int,
	@callresultinfo nvarchar ( 100 ),
	@lenqueue float,
	@timestart datetime,
	@idextline uniqueidentifier,
	@userresult int = 0,
	@idoperator uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@dtnow datetime = null
	
as 
begin	

/*	----------------------------------------
	Declare @idchain uniqueidentifier
	Declare @ideffort uniqueidentifier
	Declare @idinlist int
	Declare @idtask uniqueidentifier
	Declare @number nvarchar ( 20 )
	Declare @callresult int
	Declare @callresultinfo nvarchar ( 100 )
	Declare @lenqueue int
	Declare @timestart datetime
	Declare @idextline uniqueidentifier
	Select @idchain = 'FD024817-A629-49E6-B550-19EC14787AC8', @ideffort = '1C3468C3-A6FE-4B36-9393-B813CFFB2815', 
		@idinlist = 63, @idtask = 'D48D5F57-6B93-4529-A205-A6B5063320A4', 
		@number = '  ', @callresult = 5, @callresultinfo = '', @lenqueue = 15, @timestart = '26.02.2007 12:04:57',
		@idextline = '00000000-0000-0000-0000-000000000000'
	-----------------------------------------
*/
	if ( @dtnow is null )
		set @dtnow = GetDate()

	--    
	Declare @idproject uniqueidentifier
	Declare @isoutput bit
	Declare @idlist uniqueidentifier

	Select 	@idproject = IdProject,
		@isoutput = IsOutputTask,
		@idlist = ListId
	From A_TaskManager_Tasks 
	Where Id = @idtask

	-------------------------------------------------------------
	----     -------------------------------
	-------------------------------------------------------------

	--  
	Declare @temp table 
	( 
		IdProject	uniqueidentifier,	--1
		IdTask 		uniqueidentifier,	--1
		IsOutput	bit,			--1
		IdEffort	uniqueidentifier,	--1
		IdOperator 	uniqueidentifier,	--3
		IdInList	int,			--1
		AbonentNumber 	nvarchar ( 20 ),	--1
		CallResult	int,			--1
		CallResultInfo	nvarchar ( 100 ),	--1
		DateTimeStart 	DateTime, 		--
		DateStart 	DateTime, 		--
		TimeStart 	DateTime,		--
		DateTimeStop	DateTime,
		IdConn		uniqueidentifier,	--
		IdChain 	uniqueidentifier,	--
		IdAUser		uniqueidentifier,	--
		IdBUser		uniqueidentifier,	--
		IdExtLine 	uniqueidentifier,	--2
		LenTime 	float, 			--
		LenQueue 	float,			--1
		IsBetweenOp	bit,			--3
		OpponentInfo 	nvarchar ( 100 ),	--6
		IsHandled 	bit,			--4
		IsSuccess	bit,			--5
		IsRecorded	bit,			--
		IdRecDir	int,			--
		ALineNum	nvarchar ( 5 ),		--
		BLineNum	nvarchar ( 5 ),		--
		--ARecFile	nvarchar ( 100 ),	--
		--BRecFile 	nvarchar ( 100 )	--
		UserResult	int default 0		--7
	)

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'


	--     (0, 1)
	Insert Into @temp ( IdProject, IdTask, IsOutput, IdEffort, IdInList, AbonentNumber, CallResult, 
				CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop, 
				IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, 
				IsRecorded, IdRecDir, ALineNum, BLineNum, UserResult ) --ARecFile, BRecFile )
	Select @idproject, @idtask, @isoutput, @ideffort, @idinlist, @number, @callresult, @callresultinfo, 
		TimeStart, 
		Cast ( Floor ( Cast ( TimeStart as Float ) ) as DateTime ),
		Cast ( Cast ( TimeStart as Float ) - FLOOR ( Cast ( IsNull ( TimeStop, @dtnow ) as Float ) ) as DateTime ),
		IsNull ( TimeStop, @dtnow ),		
		Id, IdChain, AUserId, BUserId, 
		@idextline,
		Cast ( ( IsNull ( TimeStop, @dtnow ) - TimeAnswer ) as float ) * 86400 as LenTime, @lenqueue,
		IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile
		@userresult
	FROM A_Stat_Connections_1x1 With ( NOLOCK )
	Where IdChain = @idchain

	--      ?
	If ( @@rowcount = 0 )
	   begin

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 

			--IsBetweenOp, 
			IsHandled, IsSuccess,
			--IsRecorded, IdRecDir, ARecFile, BRecFile,
			UserResult
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @dtnow,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @dtnow - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0,
			--0, 0, '', '',
			@userresult
		)

		if ( @idoperator != '00000000-0000-0000-0000-000000000000' )
			Update @temp
			Set IdOperator = @idoperator
	   end
	else
	   begin
		--        
		Delete from @temp
		Where DateTimeStart < @timestart

		Declare @timeendeff datetime
		Select @timeendeff = min ( DateTimeStart ) From @temp

		Insert Into @temp 
		( 	IdProject, IdTask, IsOutput, IdEffort, 
			--IdOperator, 
			IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, DateTimeStop,
			--IdConn, IdChain, IdAUser, IdBUser, 
			IdExtLine, LenTime, LenQueue, 
			--IsBetweenOp, 
			IsHandled, IsSuccess,
			--IsRecorded, IdRecDir, ARecFile, BRecFile 
			UserResult
			)
		Values 
		( 	@idproject, @idtask, @isoutput, @ideffort, 
			--@idempty, 
			@idinlist, @number, @callresult, @callresultinfo, @timestart,
			Cast ( Floor ( Cast ( @timestart as float ) ) as DateTime ), 
			Cast ( ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) ) as DateTime ), @timeendeff,
			--@idempty, @idempty, @idempty, @idempty, 
			@idextline, 
			Cast ( @timeendeff - @timestart as float ) * 86400,  
			@lenqueue, 
			--0, 
			0, 0,
			--0, 0, '', '',
			@userresult
		)

		
		--       (3)---------
		Declare @users table ( Id uniqueidentifier primary key )
		Insert into @users
			Select Id From A_Users

		Insert into @users Values ( 'AB000000-0000-0000-0000-000000000000' )

		Update t
		Set 	IdOperator = case when ( @isoutput > 0 ) then IdAUser else IdBUser end, 
			IsBetweenOp = 0
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id or t.IDBUser = u2.Id

		Update t
		Set 	IdOperator = IdAUser, 
			IsBetweenOp = 1
		From @temp t, @users u1, @users u2
		Where t.IdAUser = u1.Id and t.IdBUser = u2.Id
		

		--  ? (4)--------------------------------
		Declare @cnt int
		Select @cnt = Count ( * ) FROM @temp t 
		Where DateTimeStart >= @timestart
		
		Update t
		Set IsHandled = case when ( @cnt > 1 ) then 1 else 0 end --   
		From @temp t

		--  ? (5)---------------------------------------
		Update t
		Set IsSuccess = case When ( @callresult = 5 ) then 1 else 0 end
		From @temp t
	   end

	--    (6)----------------
	Declare @opinfo nvarchar ( 255 )
	Select @opinfo = ''
	Update t
	Set OpponentInfo = @opinfo
	From @temp t

	--  ,     ,    (      )
	if exists ( Select * from tempdb..sysobjects Where id = object_id ( 'tempdb..#textract' ) )
		drop table #textract
	Select * into #textract 
	From @temp 
	Order by datetimestart

	if ( @isoutput = 0 ) --          
	begin
		Declare @dt1 datetime, @dt2 datetime
		-- 
		Select @dt1 = Max ( DateTimeStart ) From #textract Where DateTimeStart <= @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))
		-- 
		Select @dt2 = Min ( DateTimeStart ) From #textract Where DateTimeStart > @timestart and (( IdOperator is null ) or ( IdOperator = 'AB000000-0000-0000-0000-000000000000' ))

		if ( not @dt2 is null )--28.03.2008 for special callresults
			Delete from #textract Where DateTimeStart < @dt1 or DateTimeStart >= @dt2 or LenTime is NULL
	end

	--         
	Update #textract
	Set LenTime = 0 
	Where LenTime is null

	Update #textract
	Set DateTimeStop = DateTimeStart 
	Where DateTimeStop is null

	--  LastConnected (      )
	if ( @idinlist >= 0 )
	begin
		Declare @lc_maxdt DateTime

		Select @lc_maxdt = Max ( DateTimeStart ) 
		From #textract
		Where IdOperator != '00000000-0000-0000-0000-000000000000' 
			and IdOperator != 'AB000000-0000-0000-0000-000000000000'
			and IsHandled = 1

		if ( @@rowcount > 0 )
		begin
			Declare @lc_idoperator uniqueidentifier

			Select @lc_idoperator = IdOperator
			From #textract
			Where IdOperator != '00000000-0000-0000-0000-000000000000' 
				and IdOperator != 'AB000000-0000-0000-0000-000000000000'
				and IsHandled = 1
				and DateTimeStart = @lc_maxdt

			exec A_CallCenter_OperatorLastConnected_Set @lc_maxdt, @idproject, @idtask, @idlist, @idinlist, @number, @lc_idoperator
		end
	end

	--   EffortConnections ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] --With ( TabLock )
	Select * FROM #textract

	--      A_Cube_CC_Cat_Task
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name From A_TaskManager_Tasks Where Id = @idtask	

	--      A_Cube_CC_Cat_Project
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject

	-------------------------------------------------------------
	----    -------------------------------
	-------------------------------------------------------------
	--     DBProvider

end
GO



if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_CallCenter_OperatorLastCall_Get' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastCall_Get
GO


Create procedure dbo.A_CallCenter_OperatorLastCall_Get
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier
as
begin
	--       
	--        
	
----------------------------------------
/*
	declare @taskid uniqueidentifier, @operatorid uniqueidentifier
	select @taskid = 'C5D4BCB0-3831-432E-A611-ACBBAD6FFACC', @operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
*/
-----------------------------------------

	declare @idinlist int
	declare @number nvarchar ( 50 )
	declare @callresult int
	declare @userresult int
	declare @callresultname nvarchar ( 500 )
	declare @userresultname nvarchar ( 500 )

	declare @tableidx nvarchar ( 200 ), @tableidxname nvarchar ( 200 ), @cached bit
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxname = 'A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) )
	set @cached = 0
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
  	  if Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like @tableidxname 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IdOperator' )
    	  begin
		declare @sql nvarchar ( 4000 )
		Set @sql = '
			Select Top 1 IdInList, AbonentNumber, CallResult, UserResult
			From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
				Inner join ' + @tableidx + ' t on ec.IdInList = t.Id
			Where ec.IdTask = ''' + Cast ( @taskid as nvarchar ( 100 ) ) + '''
				 and ( t.IdOperator = ''' + Cast ( @operatorid as nvarchar ( 100 ) ) + ''' or 
					ec.IdOperator = ''' + Cast ( @operatorid as nvarchar ( 100 ) ) + ''' )
			Order by DateTimeStart desc
			'				
		
		if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
			drop table #t
		create table #t ( idinlist int, abonentnumber nvarchar ( 100 ), callresult int, userresult int )

		Insert into #t
			exec sp_sqlexec @sql

		Select Top 1 @idinlist = IdInList, @number = AbonentNumber, @callresult = CallResult, @userresult = UserResult
		From #t

		set @cached = 1
	  end
	
	if ( @cached = 0 )
	begin
	  	Select Top 1 @idinlist = IdInList, @number = AbonentNumber, @callresult = CallResult, @userresult = UserResult
	  	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
	  	Where IdTask = @taskid and IdOperator = @operatorid
	  	Order by DateTimeStart Desc
	end

	Select @callresultname = name 
	From oktell_cc_temp.dbo.A_Cube_CC_Cat_TaskResultTypes
	Where id = @callresult

	Select @userresultname = name
	From dbo.A_TaskManager_CardUserResults
	Where Id = @userresult

	if ( not @idinlist is null )
		Select @idinlist, @number, @callresult, @callresultname, @userresult, IsNull ( @userresultname, '< >' )
end
GO